Index: NEMO/branches/2020/r12377_ticket2386/src/OCE/IOM/in_out_manager.F90
===================================================================
--- NEMO/branches/2020/r12377_ticket2386/src/OCE/IOM/in_out_manager.F90	(revision 12515)
+++ NEMO/branches/2020/r12377_ticket2386/src/OCE/IOM/in_out_manager.F90	(revision 12521)
@@ -178,5 +178,5 @@
    LOGICAL       ::   lsp_area = .TRUE.     !: to make a control print over a specific area
    CHARACTER(lc) ::   cxios_context         !: context name used in xios
-   CHARACTER(lc) ::   crxios_context         !: context name used in xios to read restart
+   CHARACTER(lc) ::   crxios_context        !: context name used in xios to read restart
    CHARACTER(lc) ::   cwxios_context        !: context name used in xios to write restart file
 
Index: NEMO/branches/2020/r12377_ticket2386/src/OCE/IOM/iom.F90
===================================================================
--- NEMO/branches/2020/r12377_ticket2386/src/OCE/IOM/iom.F90	(revision 12515)
+++ NEMO/branches/2020/r12377_ticket2386/src/OCE/IOM/iom.F90	(revision 12521)
@@ -478,16 +478,4 @@
         i = i + 1; fields(i)%vname="qsr_hc_b";       fields(i)%grid="grid_N_3D"
         i = i + 1; fields(i)%vname="fraqsr_1lev";    fields(i)%grid="grid_N"
-        i = i + 1; fields(i)%vname="greenland_icesheet_mass"
-                                               fields(i)%grid="grid_scalar"
-        i = i + 1; fields(i)%vname="greenland_icesheet_timelapsed"
-                                               fields(i)%grid="grid_scalar"
-        i = i + 1; fields(i)%vname="greenland_icesheet_mass_roc"
-                                               fields(i)%grid="grid_scalar"
-        i = i + 1; fields(i)%vname="antarctica_icesheet_mass"
-                                               fields(i)%grid="grid_scalar"
-        i = i + 1; fields(i)%vname="antarctica_icesheet_timelapsed"
-                                               fields(i)%grid="grid_scalar"
-        i = i + 1; fields(i)%vname="antarctica_icesheet_mass_roc"
-                                               fields(i)%grid="grid_scalar"
         i = i + 1; fields(i)%vname="frc_v";          fields(i)%grid="grid_scalar"
         i = i + 1; fields(i)%vname="frc_t";          fields(i)%grid="grid_scalar"
@@ -549,4 +537,7 @@
         i = i + 1; fields(i)%vname="hbli";           fields(i)%grid="grid_N"
         i = i + 1; fields(i)%vname="wn";             fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="fwfisf_cav_b";   fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="isf_hc_cav_b";   fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="isf_sc_cav_b";   fields(i)%grid="grid_N"
 
         IF( i-1 > max_rst_fields) THEN
Index: NEMO/branches/2020/r12377_ticket2386/src/OCE/IOM/iom_def.F90
===================================================================
--- NEMO/branches/2020/r12377_ticket2386/src/OCE/IOM/iom_def.F90	(revision 12515)
+++ NEMO/branches/2020/r12377_ticket2386/src/OCE/IOM/iom_def.F90	(revision 12521)
@@ -67,5 +67,5 @@
    END TYPE file_descriptor
    TYPE(file_descriptor), DIMENSION(jpmax_files), PUBLIC ::   iom_file !: array containing the info for all opened files
-   INTEGER, PARAMETER, PUBLIC                   :: max_rst_fields = 95 !: maximum number of restart variables defined in iom_set_rst_vars
+   INTEGER, PARAMETER, PUBLIC                   :: max_rst_fields = 105 !: maximum number of restart variables defined in iom_set_rst_vars
    TYPE, PUBLIC :: RST_FIELD  
     CHARACTER(len=30) :: vname = "NO_NAME" ! names of variables in restart file
Index: NEMO/branches/2020/r12377_ticket2386/src/OCE/ISF/isfcav.F90
===================================================================
--- NEMO/branches/2020/r12377_ticket2386/src/OCE/ISF/isfcav.F90	(revision 12515)
+++ NEMO/branches/2020/r12377_ticket2386/src/OCE/ISF/isfcav.F90	(revision 12521)
@@ -183,7 +183,16 @@
       ! cavity mask
       mskisf_cav(:,:)    = (1._wp - tmask(:,:,1)) * ssmask(:,:)
-      !
-      !================
-      ! 2: read restart
+      !================
+      ! 2: activate restart
+      !================
+      !
+      IF( lwxios ) THEN
+         CALL iom_set_rstw_var_active('fwfisf_cav_b')
+         CALL iom_set_rstw_var_active('isf_hc_cav_b')
+         CALL iom_set_rstw_var_active('isf_sc_cav_b')
+      ENDIF
+      !
+      !================
+      ! 3: read restart
       !================
       !