Index: /utils/CI/sette_ticket2386/sette_test-cases.sh
===================================================================
--- /utils/CI/sette_ticket2386/sette_test-cases.sh	(revision 12521)
+++ /utils/CI/sette_ticket2386/sette_test-cases.sh	(revision 12522)
@@ -181,4 +181,9 @@
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
+    if [ ${USING_XIOS_RRW} == "yes" ]
+       then
+       set_namelist namelist_cfg nn_wxios 1
+    fi
+
     if [ ${USING_MPMD} == "yes" ] ; then
        set_xio_using_server iodef.xml true
@@ -204,4 +209,10 @@
     set_namelist namelist_cfg nn_rstctl 2
     set_namelist namelist_cfg cn_ocerst_in \"OVF_LONG_00000060_restart\"
+    if [ ${USING_XIOS_RRW} == "yes" ]
+       then
+       set_namelist namelist_cfg nn_wxios 1
+       set_namelist namelist_cfg ln_xios_read .true.
+    fi
+
     if [ ${USING_MPMD} == "yes" ] ; then
        set_xio_using_server iodef.xml true
@@ -379,4 +390,9 @@
     set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
+
+    if [ ${USING_XIOS_RRW} == "yes" ]
+       then
+       set_namelist namelist_cfg nn_wxios 1
+    fi
 	
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -413,4 +429,10 @@
     set_namelist 1_namelist_cfg nn_rstctl 2
     set_namelist 1_namelist_cfg cn_ocerst_in \"VORTEX_LONG_00000360_restart\"
+
+    if [ ${USING_XIOS_RRW} == "yes" ]
+       then
+       set_namelist namelist_cfg nn_wxios 1
+       set_namelist namelist_cfg ln_xios_read .true.
+    fi
       
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -419,5 +441,5 @@
         set_xio_using_server iodef.xml false
     fi
-    if [ $NPROC -eq 1 ] ;  then
+    if [[ ($NPROC -eq 1 || ${USING_XIOS_RRW} == "yes") ]];  then
         ln -sf ../LONG/VORTEX_LONG_00000120_restart.nc .
         ln -sf ../LONG/1_VORTEX_LONG_00000360_restart.nc .
@@ -548,4 +570,9 @@
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist 1_namelist_cfg nn_stock 300
+
+    if [ ${USING_XIOS_RRW} == "yes" ]
+       then
+       set_namelist namelist_cfg nn_wxios 1
+    fi
     
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -584,5 +611,10 @@
     set_namelist 1_namelist_cfg cn_ocerst_in \"ICE_AGRIF_LONG_00000300_restart\"
     set_namelist 1_namelist_ice_cfg cn_icerst_in \"ICE_AGRIF_LONG_00000300_restart_ice\"
-    
+
+    if [ ${USING_XIOS_RRW} == "yes" ]
+       then
+       set_namelist namelist_cfg nn_wxios 1
+       set_namelist namelist_cfg ln_xios_read .true.
+    fi
     
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -591,5 +623,5 @@
         set_xio_using_server iodef.xml false
     fi
-    if [ $NPROC -eq 1 ] ;  then
+    if [[ ($NPROC -eq 1 || ${USING_XIOS_RRW} == "yes") ]] ;  then
         ln -sf ../LONG/ICE_AGRIF_LONG_00000100_restart.nc .
         ln -sf ../LONG/ICE_AGRIF_LONG_00000100_restart_ice.nc .
@@ -720,4 +752,8 @@
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
+    if [ ${USING_XIOS_RRW} == "yes" ]
+       then
+       set_namelist namelist_cfg nn_wxios 1
+    fi
     if [ ${USING_MPMD} == "yes" ] ; then
        set_xio_using_server iodef.xml true
@@ -745,15 +781,23 @@
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg cn_ocerst_in \"ISOMIP_LONG_00000048_restart\"
-    if [ ${USING_MPMD} == "yes" ] ; then
-       set_xio_using_server iodef.xml true
-    else
-       set_xio_using_server iodef.xml false
-    fi
-    for (( i=1; i<=$NPROC; i++)) ; do
-        L_NPROC=$(( $i - 1 ))
-        L_NPROC=`printf "%04d\n" ${L_NPROC}`
-        ln -sf ../LONG/ISOMIP_LONG_00000048_restart_${L_NPROC}.nc .
-    done
-
+    if [ ${USING_XIOS_RRW} == "yes" ]
+       then
+       set_namelist namelist_cfg nn_wxios 1
+       set_namelist namelist_cfg ln_xios_read .true.
+    fi
+    if [ ${USING_MPMD} == "yes" ] ; then
+       set_xio_using_server iodef.xml true
+    else
+       set_xio_using_server iodef.xml false
+    fi
+    if [ ${USING_XIOS_RRW} == "yes" ]; then
+        ln -sf ../LONG/ISOMIP_LONG_00000048_restart.nc .
+    else
+        for (( i=1; i<=$NPROC; i++)) ; do
+            L_NPROC=$(( $i - 1 ))
+            L_NPROC=`printf "%04d\n" ${L_NPROC}`
+            ln -sf ../LONG/ISOMIP_LONG_00000048_restart_${L_NPROC}.nc .
+        done
+    fi
     cd ${SETTE_DIR}
     . ./prepare_job.sh input_ISOMIP.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}