Index: NEMO/branches/UKMO/NEMO_4.0.1_GO8_package/cfgs/SHARED/field_def_nemo-oce.xml
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.1_GO8_package/cfgs/SHARED/field_def_nemo-oce.xml	(revision 11742)
+++ NEMO/branches/UKMO/NEMO_4.0.1_GO8_package/cfgs/SHARED/field_def_nemo-oce.xml	(revision 12574)
@@ -22,9 +22,15 @@
         <field id="e3t_surf"     long_name="T-cell thickness"   field_ref="e3t"  standard_name="cell_thickness"     unit="m"   grid_ref="grid_T_surface_extract"/>
         <field id="e3t_0"        long_name="Initial T-cell thickness"            standard_name="ref_cell_thickness" unit="m"   grid_ref="grid_T_3D" />
-
-        <field id="toce"         long_name="temperature"                         standard_name="sea_water_potential_temperature"   unit="degC"     grid_ref="grid_T_3D"/>
-        <field id="toce_e3t"     long_name="temperature (thickness weighted)"                                                      unit="degC"     grid_ref="grid_T_3D" > toce * e3t </field >
-        <field id="soce"         long_name="salinity"                            standard_name="sea_water_practical_salinity"      unit="1e-3"     grid_ref="grid_T_3D"/>
-        <field id="soce_e3t"     long_name="salinity    (thickness weighted)"                                                      unit="1e-3"     grid_ref="grid_T_3D" > soce * e3t </field >
+        
+        <!-- EOS80 -->
+        <field id="toce_pot"         long_name="potential temperature"           standard_name="sea_water_potential_temperature"      unit="degC"     grid_ref="grid_T_3D"/>
+        <field id="toce_pot_e3t"     long_name="potential temperature (thickness weighted)"                                           unit="degC"     grid_ref="grid_T_3D" > toce_pot * e3t </field >
+        <field id="soce_pra"         long_name="practical salinity"              standard_name="sea_water_practical_salinity"      unit="1e-3"     grid_ref="grid_T_3D"/>
+        <field id="soce_pra_e3t"     long_name="practical salinity    (thickness weighted)"                                        unit="1e-3"     grid_ref="grid_T_3D" > soce_pra * e3t </field >
+        <!-- TEOS10 -->
+        <field id="toce_con"         long_name="conservative temperature"        standard_name="sea_water_conservative_temperature"   unit="degC"     grid_ref="grid_T_3D"/>
+        <field id="toce_con_e3t"     long_name="conservative temperature (thickness weighted)"                                        unit="degC"     grid_ref="grid_T_3D" > toce_con * e3t </field >  
+        <field id="soce_abs"         long_name="absolute salinity"               standard_name="sea_water_absolute_salinity"       unit="1e-3"     grid_ref="grid_T_3D"/>
+        <field id="soce_abs_e3t"     long_name="absolute salinity    (thickness weighted)"                                         unit="1e-3"     grid_ref="grid_T_3D" > soce_abs * e3t </field >
 
         <!-- t-eddy viscosity coefficients (ldfdyn) -->
@@ -32,22 +38,42 @@
 	<field id="ahmt_3d"      long_name=" 3D      t-eddy viscosity coefficient"   unit="m2/s or m4/s"  grid_ref="grid_T_3D"/>
 
-        <field id="sst"          long_name="sea surface temperature"                            standard_name="sea_surface_temperature"             unit="degC"     />
-        <field id="sst2"         long_name="square of sea surface temperature"                  standard_name="square_of_sea_surface_temperature"   unit="degC2"     > sst * sst </field >
-        <field id="sstmax"       long_name="max of sea surface temperature"   field_ref="sst"   operation="maximum"                                                 />
-        <field id="sstmin"       long_name="min of sea surface temperature"   field_ref="sst"   operation="minimum"                                                 />
-        <field id="sstgrad"      long_name="module of sst gradient"                                                                                 unit="degC/m"   />
-        <field id="sstgrad2"     long_name="square of module of sst gradient"                                                                       unit="degC2/m2" />
-        <field id="sbt"          long_name="sea bottom temperature"                                                                                 unit="degC"     />
-        <field id="tosmint"      long_name="vertical integral of temperature times density"     standard_name="integral_wrt_depth_of_product_of_density_and_potential_temperature"  unit="(kg m2) degree_C" />
-        <field id="sst_wl"       long_name="Delta SST of warm layer"                                                                                unit="degC"     />
-        <field id="sst_cs"       long_name="Delta SST of cool skin"                                                                                 unit="degC"     />
-	<field id="temp_3m"      long_name="temperature at 3m"                                                                                      unit="degC"     />
-        
-        <field id="sss"          long_name="sea surface salinity"                               standard_name="sea_surface_salinity"                unit="1e-3"     />
-        <field id="sss2"         long_name="square of sea surface salinity"                                                                         unit="1e-6"      > sss * sss </field >
-        <field id="sssmax"       long_name="max of sea surface salinity"      field_ref="sss"   operation="maximum"                                                 />
-        <field id="sssmin"       long_name="min of sea surface salinity"      field_ref="sss"   operation="minimum"                                                 />
-        <field id="sbs"          long_name="sea bottom salinity"                                                                                    unit="0.001"    />
-        <field id="somint"       long_name="vertical integral of salinity times density"        standard_name="integral_wrt_depth_of_product_of_density_and_salinity"  unit="(kg m2) x (1e-3)" /> 
+        <!-- EOS80 -->
+        <field id="sst_pot"          long_name="sea surface potential temperature"                            standard_name="sea_surface_temperature"             unit="degC"     />
+        <field id="sst2_pot"         long_name="square of sea surface potential temperature"                  standard_name="square_of_sea_surface_temperature"   unit="degC2"     > sst_pot * sst_pot </field >
+        <field id="sstmax_pot"       long_name="max of sea surface potential temperature"   field_ref="sst_pot"   operation="maximum"                                                 />
+        <field id="sstmin_pot"       long_name="min of sea surface potential temperature"   field_ref="sst_pot"   operation="minimum"                                                 />
+        <field id="sstgrad_pot"      long_name="module of potential sst gradient"                                                                                 unit="degC/m"   />
+        <field id="sstgrad2_pot"     long_name="square of module of potential sst gradient"                                                                       unit="degC2/m2" />
+        <field id="sbt_pot"          long_name="sea bottom potential temperature"                                                                                 unit="degC"     />
+        <field id="tosmint_pot"      long_name="vertical integral of potential temperature times density"     standard_name="integral_wrt_depth_of_product_of_density_and_potential_temperature"  unit="(kg m2) degree_C" />
+        <field id="sst_wl_pot"       long_name="Delta potential SST of warm layer"                                                                                unit="degC"     />
+        <field id="sst_cs_pot"       long_name="Delta potential SST of cool skin"                                                                                 unit="degC"     />
+	<field id="temp_3m_pot"      long_name="potential temperature at 3m"                                                                                      unit="degC"     />
+
+        <field id="sss_pra"          long_name="sea surface practical salinity"                               standard_name="sea_surface_practical_salinity"                unit="1e-3"     />
+        <field id="sss2_pra"         long_name="square of sea surface practical salinity"                                                                         unit="1e-6"      > sss_pra * sss_pra </field >
+        <field id="sssmax_pra"       long_name="max of sea surface practical salinity"      field_ref="sss_pra"   operation="maximum"                                                 />
+        <field id="sssmin_pra"       long_name="min of sea surface practical salinity"      field_ref="sss_pra"   operation="minimum"                                                 />
+        <field id="sbs_pra"          long_name="sea bottom practical salinity"                                                                                    unit="0.001"    />
+        <field id="somint_pra"       long_name="vertical integral of practical salinity times density"        standard_name="integral_wrt_depth_of_product_of_density_and_practical_salinity"  unit="(kg m2) x (1e-3)" /> 
+        <!-- TEOS10 -->
+        <field id="sst_con"          long_name="sea surface conservative temperature"                            standard_name="sea_surface_conservative_temperature"             unit="degC"     />
+        <field id="sst2_con"         long_name="square of sea surface conservative temperature"                  standard_name="square_of_sea_surface_temperature"   unit="degC2"     > sst_con * sst_con </field >
+        <field id="sstmax_con"       long_name="max of sea surface conservative temperature"   field_ref="sst_con"   operation="maximum"                                                 />
+        <field id="sstmin_con"       long_name="min of sea surface conservative temperature"   field_ref="sst_con"   operation="minimum"                                                 />
+        <field id="sstgrad_con"      long_name="module of conservative sst gradient"                                                                                 unit="degC/m"   />
+        <field id="sstgrad2_con"     long_name="square of module of conservative sst gradient"                                                                       unit="degC2/m2" />
+        <field id="sbt_con"          long_name="sea bottom conservative temperature"                                                                                 unit="degC"     />
+        <field id="tosmint_con"      long_name="vertical integral of conservative temperature times density"     standard_name="integral_wrt_depth_of_product_of_density_and_conservative_temperature"  unit="(kg m2) degree_C" />
+        <field id="sst_wl_con"       long_name="Delta conservative SST of warm layer"                                                                                unit="degC"     />
+        <field id="sst_cs_con"       long_name="Delta conservative SST of cool skin"                                                                                 unit="degC"     />
+	<field id="temp_3m_con"      long_name="conservative temperature at 3m"                                                                                      unit="degC"     />
+
+        <field id="sss_abs"          long_name="sea surface absolute salinity"                               standard_name="sea_surface_absolute_salinity"                unit="1e-3"     />
+        <field id="sss2_abs"         long_name="square of sea surface absolute salinity"                                                                         unit="1e-6"      > sss_abs * sss_abs </field >
+        <field id="sssmax_abs"       long_name="max of sea surface absolute salinity"      field_ref="sss_abs"   operation="maximum"                                                 />
+        <field id="sssmin_abs"       long_name="min of sea surface absolute salinity"      field_ref="sss_abs"   operation="minimum"                                                 />
+        <field id="sbs_abs"          long_name="sea bottom absolute salinity"                                                                                    unit="0.001"    />
+        <field id="somint_abs"       long_name="vertical integral of absolute salinity times density"        standard_name="integral_wrt_depth_of_product_of_density_and_absolute_salinity"  unit="(kg m2) x (1e-3)" />
 
         <field id="taubot"       long_name="bottom stress module"                                                                                   unit="N/m2"     /> 
@@ -343,6 +369,10 @@
 	  
 	  <!-- sbcssm variables -->
-          <field id="sst_m"    unit="degC" />
-          <field id="sss_m"    unit="psu"  />
+          <field id="sst_m_pot"    unit="degC" />
+	  <!-- EOS-80 -->
+          <field id="sss_m_pra"    unit="psu"  />
+          <!-- TEOS-10 -->
+          <field id="sss_m_abs"    unit="psu"  />
+
           <field id="ssu_m"    unit="m/s"  />
           <field id="ssv_m"    unit="m/s"  />
@@ -898,6 +928,11 @@
     
     <field_group id="mooring" >
-      <field field_ref="toce"         name="thetao"   long_name="sea_water_potential_temperature"      />
-      <field field_ref="soce"         name="so"       long_name="sea_water_salinity"                   />
+      <!-- EOS80 -->
+      <field field_ref="toce_pot"         name="thetao_pot"   long_name="sea_water_potential_temperature"      />
+      <field field_ref="soce_pra"         name="so_pra"       long_name="sea_water_practical_salinity"                   />
+      <!-- TEOS10 -->
+      <field field_ref="toce_con"         name="thetao_con"   long_name="sea_water_conservative_temperature"      />
+      <field field_ref="soce_abs"         name="so_con"       long_name="sea_water_absolute_salinity"                   />
+
       <field field_ref="uoce"         name="uo"       long_name="sea_water_x_velocity"                 />
       <field field_ref="voce"         name="vo"       long_name="sea_water_y_velocity"                 />
@@ -905,9 +940,16 @@
       <field field_ref="avt"          name="difvho"   long_name="ocean_vertical_heat_diffusivity"      />
       <field field_ref="avm"          name="difvmo"   long_name="ocean_vertical_momentum_diffusivity"  />
-      
-      <field field_ref="sst"          name="tos"      long_name="sea_surface_temperature"                       />
-      <field field_ref="sst2"         name="tossq"    long_name="square_of_sea_surface_temperature"             />
-      <field field_ref="sstgrad"      name="tosgrad"  long_name="module_of_sea_surface_temperature_gradient"    />
-      <field field_ref="sss"          name="sos"      long_name="sea_surface_salinity"                          />
+
+      <!-- EOS80 -->
+      <field field_ref="sst_pot"          name="tos_pot"      long_name="sea_surface_potential_temperature"                       />
+      <field field_ref="sst2_pot"         name="tossq_pot"    long_name="square_of_sea_surface_potential_temperature"             />
+      <field field_ref="sstgrad_pot"      name="tosgrad_pot"  long_name="module_of_sea_surface_potential_temperature_gradient"    />
+      <field field_ref="sss_pra"          name="sos_pra"      long_name="sea_surface_absolute_salinity"                          />
+      <!-- TEOS10 -->
+      <field field_ref="sst_con"          name="tos_con"      long_name="sea_surface_conservative_temperature"                       />
+      <field field_ref="sst2_con"         name="tossq_con"    long_name="square_of_sea_surface_conservative_temperature"             />
+      <field field_ref="sstgrad_con"      name="tosgrad_con"  long_name="module_of_sea_surface_conservative_temperature_gradient"    />
+      <field field_ref="sss_abs"          name="sos"      long_name="sea_surface_absolute_salinity"                          />
+
       <field field_ref="ssh"          name="zos"      long_name="sea_surface_height_above_geoid"                />
       <field field_ref="empmr"        name="wfo"      long_name="water_flux_into_sea_water"                     />
@@ -932,9 +974,17 @@
 
     <field_group id="groupT" >
-      <field field_ref="toce"         name="thetao"   long_name="sea_water_potential_temperature"               />
-      <field field_ref="soce"         name="so"       long_name="sea_water_salinity"                            />
-      <field field_ref="sst"          name="tos"      long_name="sea_surface_temperature"                       />
-      <field field_ref="sst2"         name="tossq"    long_name="square_of_sea_surface_temperature"             />
-      <field field_ref="sss"          name="sos"      long_name="sea_surface_salinity"                          />
+      <!-- EOS80 -->
+      <field field_ref="toce_pot"         name="thetao_pot"   long_name="sea_water_potential_temperature"               />
+      <field field_ref="soce_pra"         name="so_pra"       long_name="sea_water_practical_salinity"                            />
+      <field field_ref="sst_pot"          name="tos_pot"      long_name="sea_surface_potential_temperature"                       />
+      <field field_ref="sst2_pot"         name="tossq_pot"    long_name="square_of_sea_surface_potential_temperature"             />
+      <field field_ref="sss_pra"          name="sos_pra"      long_name="sea_surface_practical_salinity"                          />
+      <!-- TEOS10 -->
+      <field field_ref="toce_con"         name="thetao_con"   long_name="sea_water_conservative_temperature"               />
+      <field field_ref="soce_abs"         name="so_abs"       long_name="sea_water_absolute_salinity"                            />
+      <field field_ref="sst_con"          name="tos_con"      long_name="sea_surface_conservative_temperature"                       />
+      <field field_ref="sst2_con"         name="tossq_con"    long_name="square_of_sea_surface_conservative_temperature"             />
+      <field field_ref="sss_abs"          name="sos_abs"      long_name="sea_surface_absolute_salinity"                          />
+
       <field field_ref="ssh"          name="zos"      long_name="sea_surface_height_above_geoid"                />
       <field field_ref="empmr"        name="wfo"      long_name="water_flux_into_sea_water"                     />
@@ -972,10 +1022,19 @@
     <!-- TMB diagnostic output -->
     <field_group  id="1h_grid_T_tmb" grid_ref="grid_T_2D" operation="instant">
-      <field id="top_temp"           name="votemper_top"  unit="degC"  />
-      <field id="mid_temp"           name="votemper_mid"  unit="degC"  />
-      <field id="bot_temp"           name="votemper_bot"  unit="degC"  />
-      <field id="top_sal"            name="vosaline_top"  unit="psu"   />
-      <field id="mid_sal"            name="vosaline_mid"  unit="psu"   />
-      <field id="bot_sal"            name="vosaline_bot"  unit="psu"   />
+      <!-- EOS80 -->
+      <field id="top_temp_pot"           name="votemper_top_pot"  unit="degC"  />
+      <field id="mid_temp_pot"           name="votemper_mid_pot"  unit="degC"  />
+      <field id="bot_temp_pot"           name="votemper_bot_pot"  unit="degC"  />
+      <field id="top_sal_pra"            name="vosaline_top_pra"  unit="psu"   />
+      <field id="mid_sal_pra"            name="vosaline_mid_pra"  unit="psu"   />
+      <field id="bot_sal_pra"            name="vosaline_bot_pra"  unit="psu"   />
+      <!-- TEOS10 -->
+      <field id="top_temp_con"           name="votemper_top_con"  unit="degC"  />
+      <field id="mid_temp_con"           name="votemper_mid_con"  unit="degC"  />
+      <field id="bot_temp_con"           name="votemper_bot_con"  unit="degC"  />
+      <field id="top_sal_abs"            name="vosaline_top_abs"  unit="psu"   />
+      <field id="mid_sal_abs"            name="vosaline_mid_abs"  unit="psu"   />
+      <field id="bot_sal_abs"            name="vosaline_bot_abs"  unit="psu"   />
+
       <field id="sshnmasked"         name="sossheig"      unit="m"     /> 
     </field_group>
@@ -997,7 +1056,13 @@
     <!-- 25h diagnostic output -->
     <field_group id="25h_grid_T" grid_ref="grid_T_3D" operation="instant">
-      <field id="temper25h"         name="potential temperature 25h mean"    unit="degC" />
+      <!-- EOS80 -->
+      <field id="temper25h_pot"         name="potential temperature 25h mean"    unit="degC" />
       <field id="tempis25h"         name="insitu temperature 25h mean"    unit="degC" />
-      <field id="salin25h"          name="salinity 25h mean"                 unit="psu"  />
+      <field id="salin25h_pra"          name="practical salinity 25h mean"                 unit="psu"  />
+      <!-- TEOS10 -->
+      <field id="temper25h_con"         name="conservative temperature 25h mean"    unit="degC" />
+      <field id="tempis25h"         name="insitu temperature 25h mean"    unit="degC" />
+      <field id="salin25h_abs"          name="absolute salinity 25h mean"                 unit="psu"  />
+
       <field id="ssh25h"            name="sea surface height 25h mean"  grid_ref="grid_T_2D"      unit="m"    />
     </field_group>